using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

namespace SpanCol
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();


			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			InitializeColumns();
			ArrayList list = new ArrayList();
			for (int i=0; i< 10; i++)
			{	
				
				string[] col = new string[10];
				for(int j=0;j<10;j++)
					col[j] = string.Format("row{0}, col{1}",i,j);
				Source source = new Source(col);
				list.Add(source);
			}
			this.gridGroupingControl1.DataSource = list;

			this.gridGroupingControl1.TableControlCurrentCellActivated += new GridTableControlEventHandler(gridGrouping_TableControlCurrentCellActivated);


		}

		#region IntializeColumns
		private void InitializeColumns()
		{


			// GridColumnDescriptors
			GridColumnDescriptor desc1 = new GridColumnDescriptor();
			GridColumnDescriptor desc2 = new GridColumnDescriptor();
			GridColumnDescriptor desc3 = new GridColumnDescriptor();
			GridColumnDescriptor desc4 = new GridColumnDescriptor();
			GridColumnDescriptor desc5 = new GridColumnDescriptor();
			GridColumnDescriptor desc6 = new GridColumnDescriptor();
			GridColumnDescriptor desc7 = new GridColumnDescriptor();
			GridColumnDescriptor desc8 = new GridColumnDescriptor();
			GridColumnDescriptor desc9 = new GridColumnDescriptor();
			GridColumnDescriptor desc10 = new GridColumnDescriptor();
	
			desc1.MappingName = "C1";
			desc1.Width = 60;
	
			desc2.MappingName = "C2";
			desc2.Width = 60;
	
			desc3.MappingName = "C3";
			desc3.Width = 80;
			
			desc4.MappingName = "C4";
			desc4.Width = 80;


			desc5.MappingName = "C5";
			desc5.Width = 60;

			desc6.MappingName = "C6";
			desc6.Width = 60;

			desc7.MappingName = "C7";
			desc7.Width = 60;

			desc8.MappingName = "C8";
			desc8.Width = 40;

			desc9.MappingName = "C9";
			desc9.Width = 100;

			desc10.MappingName = "C10";
			desc10.Width = 60;


			this.gridGroupingControl1.TableDescriptor.Columns.AddRange(
				new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor[] {
																					  desc1,
																					  desc2,
																					  desc3,
																					  desc4,
																					  desc5,
																					  desc6,
																					  desc7,
																					  desc8,
																					  desc9,
																					  desc10
																					});


			// GridColumnDescriptorSet / Multi Row Headers

			GridColumnSetDescriptor setDesc1 = new GridColumnSetDescriptor();
			GridColumnSetDescriptor setDesc2 = new GridColumnSetDescriptor();
			GridColumnSetDescriptor setDesc3 = new GridColumnSetDescriptor();


			setDesc1.Name = "sp1";
			setDesc1.ColumnSpans.AddRange(new GridColumnSpanDescriptor[] {
																			 new GridColumnSpanDescriptor("C1", "R0C0"),
																			 new GridColumnSpanDescriptor("C2", "R1C0")});

			setDesc2.Name = "sp2";
			setDesc2.ColumnSpans.AddRange(new GridColumnSpanDescriptor[] {
																			 new GridColumnSpanDescriptor("C3", "R0C0"),
																			 new GridColumnSpanDescriptor("C5", "R0C1"),
																			 new GridColumnSpanDescriptor("C4", "R1C0:R1C1")});

			setDesc3.Name = "sp3";
			setDesc3.ColumnSpans.AddRange(new GridColumnSpanDescriptor[] {
																			 
																			 new GridColumnSpanDescriptor("C6", "R0C0"),
																			 new GridColumnSpanDescriptor("C7", "R0C1"),
																			 new GridColumnSpanDescriptor("C8", "R0C2"),
																			 new GridColumnSpanDescriptor("C10", "R0C3"),
																			 new GridColumnSpanDescriptor("C9","R1C0:R1C3")});





			this.gridGroupingControl1.TableDescriptor.ColumnSets.AddRange(new GridColumnSetDescriptor[]
													{
														setDesc1,
														setDesc2,
														setDesc3,
													});



		}

		#endregion

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(8, 8);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(464, 496);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableOptions.ListBoxSelectionColorOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionColorOptions.DrawAlphablend;
			this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.One;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.62";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(480, 510);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void gridGrouping_TableControlCurrentCellActivated(object sender, GridTableControlEventArgs e)
		{
			Element el = this.gridGroupingControl1.Table.CurrentElement;
			if(el is GridRecord)
			{
				GridRecord rec = el as GridRecord;
				if(rec != null)
				{
					Source  src = rec.GetData() as Source;
					Console.Write("RowIndex:"+e.TableControl.CurrentCell.RowIndex.ToString()+" ");
					Console.WriteLine(src);
				}
			}
		}
	}
}
